/**
 * \file generate_map.cpp
 * \brief 简要介绍
 * \details 详细说明
 * \author lenotary
 * \version 1.0
 * \date 2021/12/22
 * \pre 先决条件。（有的话才添加。）
 * \bug 存在的bug。（有的话才添加，注明“还未发现”也可以。）
 * \warning 警告。（有的话才添加。）
 * \copyright 版权声明。（通常只写遵循什么协议，版权详细内容应放在LICENSE文件中，并且应该与LICENSE文件的内容统一，不能自相矛盾。）
 * \since 一些历史情况记录。（有的话才添加。）
 */
//
// Created by lenotary on 2021/12/22.
//
#include <liblas/liblas.hpp>
#include <ros/ros.h>
#include <pcl/pcl_base.h>
#include <pcl/point_cloud.h>
#include <pcl_conversions/pcl_conversions.h>
#include <pcl/point_types.h>
#include <pcl/common/transforms.h>
#include <tf/transform_datatypes.h>
#include <pcl/io/io.h>
#include <ros/ros.h>
#include <iostream>
#include <fstream>
#include <sstream>    //使用stringstream需要引入这个头文件
#include <Eigen/Eigen>
#include <Eigen/Dense>
#include <Eigen/Geometry>
#include <Eigen/Eigenvalues>
#include <fstream>
#include <sstream>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/Imu.h>
#include <std_msgs/Float64.h>
#include <std_msgs/String.h>
#include <queue>
#include <mutex>

ros::Publisher pubResult;
ros::Publisher pubMotorPose;
std::queue<sensor_msgs::Imu> bufferImu;

std::mutex imuMutex;
std::mutex cloudMutex;

double generateStartTime, runStartTime;
int scanCount, runEndCount;
bool isScan, localScanEnd, isGenerate, isRunEnd;
sensor_msgs::Imu imuMsg;
std_msgs::Float64 targetPose;
pcl::PointCloud<pcl::PointXYZI>::Ptr mapCloud;

pcl::PointCloud<pcl::PointXYZI>::Ptr transformPointCloud(pcl::PointCloud<pcl::PointXYZI>::Ptr cloudIn, Eigen::Affine3f transCur);

void callBackImu(const sensor_msgs::Imu::ConstPtr &msg) {
    tf::Quaternion quat;
    tf::quaternionMsgToTF(msg->orientation, quat);
    double roll, pitch, yaw;//定义存储r\p\y的容器
    tf::Matrix3x3(quat).getRPY(roll, pitch, yaw);//进行转换
    imuMsg = *msg;
    imuMutex.lock();
    bufferImu.push(*msg);
    if (isScan) {
        if (scanCount == 1 and !isGenerate and isRunEnd) {
            targetPose.data += 0.2;
            if (targetPose.data > M_PI) {
                targetPose.data = M_PI;
            }
            isRunEnd = false;
            runEndCount = 0;
            runStartTime = ros::Time::now().toSec();
            pubMotorPose.publish(targetPose);

        } else if (scanCount == 2 and !isGenerate and isRunEnd) {
            targetPose.data -= 0.2;
            isRunEnd = false;
            runEndCount = 0;

            if (targetPose.data < -M_PI) {
                targetPose.data = -M_PI;
            }
            pubMotorPose.publish(targetPose);
            runStartTime = ros::Time::now().toSec();

        } else if (scanCount == 3 and !isGenerate and isRunEnd) {

            pubMotorPose.publish(targetPose);
            targetPose.data += 0.2;
            isRunEnd = false;
            runEndCount = 0;
            pubMotorPose.publish(targetPose);
            runStartTime = ros::Time::now().toSec();

        }
        if (not isRunEnd and std::abs(targetPose.data - yaw) < 0.01) {
            runEndCount++;
            if (scanCount == 1 and std::abs(targetPose.data - M_PI) < 0.01) {
                scanCount++;
            } else if (scanCount == 2 and std::abs(targetPose.data + M_PI) < 0.01) {
                scanCount++;
            } else if (scanCount == 3 and targetPose.data > 0) {
                targetPose.data = 0;
                scanCount = 1;
                isScan = false;
                ROS_INFO("stop generate auto");
            }
            if (runEndCount > 10) {
                isRunEnd = true;
                isGenerate = true;
                generateStartTime = ros::Time::now().toSec();
//                ROS_INFO("info pose error %f time error %f",yaw- targetPose.data,ros::Time::now().toSec() - runStartTime);
            }
        }
        if (ros::Time::now().toSec() - generateStartTime > 1.0) {
            isGenerate = false;
        }
    }

    imuMutex.unlock();


}

void callBackCloud(const sensor_msgs::PointCloud2::ConstPtr &msg) {

    imuMutex.lock();
    if (isGenerate) {
//        double roll, pitch, yaw;//定义存储r\p\y的容器
//        tf::Quaternion quat;
//        tf::quaternionMsgToTF(imuMsg.orientation, quat);
//        tf::Matrix3x3(quat).getRPY(roll, pitch, yaw);//进行转换
//
//        Eigen::Affine3f transform = Eigen::Affine3f::Identity();
//        transform.rotate(Eigen::AngleAxisf(yaw, Eigen::Vector3f::UnitZ()));
////            std::cout << transform <<std::endl;
//        pcl::PointCloud<pcl::PointXYZI>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZI>);
//        pcl::fromROSMsg(*msg, *cloud);
//        *mapCloud += *transformPointCloud(cloud, transform);
    }
    imuMutex.unlock();
}

void callControl(const std_msgs::String::ConstPtr &msg) {
    if (msg->data == "start") {
        isScan = true;
        targetPose.data = 0;
        scanCount = 1;
        pubMotorPose.publish(targetPose);
        ROS_INFO("start generate");
    } else if (msg->data == "stop") {
        isScan = false;
        ROS_INFO("stop generate manual");
    }
}
pcl::PointCloud<pcl::PointXYZI>::Ptr transformPointCloud(pcl::PointCloud<pcl::PointXYZI>::Ptr cloudIn, Eigen::Affine3f transCur) {
    pcl::PointCloud<pcl::PointXYZI>::Ptr cloudOut(new pcl::PointCloud<pcl::PointXYZI>());

    pcl::PointXYZI *pointFrom;

    int cloudSize = cloudIn->size();
    cloudOut->resize(cloudSize);

//    Eigen::Affine3f transCur = pcl::getTransformation(transformIn->x, transformIn->y, transformIn->z,
//                                                      transformIn->roll, transformIn->pitch, transformIn->yaw);

    for (int i = 0; i < cloudSize; ++i) {
        pointFrom = &cloudIn->points[i];
        cloudOut->points[i].x =
                transCur(0, 0) * pointFrom->x + transCur(0, 1) * pointFrom->y + transCur(0, 2) * pointFrom->z +
                transCur(0, 3);
        cloudOut->points[i].y =
                transCur(1, 0) * pointFrom->x + transCur(1, 1) * pointFrom->y + transCur(1, 2) * pointFrom->z +
                transCur(1, 3);
        cloudOut->points[i].z =
                transCur(2, 0) * pointFrom->x + transCur(2, 1) * pointFrom->y + transCur(2, 2) * pointFrom->z +
                transCur(2, 3);
        cloudOut->points[i].intensity = pointFrom->intensity;
    }
    return cloudOut;
}
int main(int argc, char **argv) {
    ros::init(argc, argv, "node");
    ros::NodeHandle nh;
    ros::NodeHandle nhPrivate("~");


    pubResult = nh.advertise<std_msgs::String>("result", 1);
    pubMotorPose = nh.advertise<std_msgs::Float64>("motor_set_pose", 1);
    ros::Subscriber subImu = nh.subscribe("motor_pose_imu", 1000, &callBackImu);
    ros::Subscriber subCloud = nh.subscribe("livox/lidar", 1, &callBackCloud);
    ros::Subscriber subControl = nh.subscribe("generate_control", 1, &callControl);
    mapCloud.reset(new pcl::PointCloud<pcl::PointXYZI>);
    scanCount = 0;
    isScan = false;
    localScanEnd = false;
    isGenerate = false;
    isRunEnd = false;

    while (ros::ok()) {

        ros::spinOnce();
    }

    return 0;
}